﻿Type=StaticCode
Version=3.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module

Sub Process_Globals
	Private fx As JFX
	Private start As String
	Private fin As String
	Private bs As String
	Private bcolor As Int
	Private fcolor As Int
	Dim su As StringUtilities
	
	
End Sub



'Description: Generates Code11 barcode and saves it in the /pictures folder as "Code11.png" from where it can be loaded into for eg an ImageView
'
'Method of calling:
'success = Code11.Draw_Code11(message, start_chr, stop_chr, back_color, front_color)
'
'where 'success' = indication of successful encoding (0 = successful, 1 = not successful) - type Int
'successful = all input chars are valid input chars (lower case will automatically be converted to upper case)
'where 'message' = message to be encoded - type String
'where 'start_chr' = start character (A, B, C, or D) - type String
'where 'stop_chr' = stop character (A, B, C, or D) - type String
'where 'back_color' = background color of the code - type Int
'where 'front_color' = foreground color of the code (solid bar color) - type Int
'example of parameters to pass:
'message = "40156" 
'strt = "A"
'stp = "B"
'back_color = Colors.Yellow
'fore_color = Colors.Black
Public Sub Draw_Code11 (message As String, strt As String, stp As String) As String

Dim flag As Int
su.Initialize

Dim karak, new_mes As String

If strt = "a" Then strt = "A"
If strt = "b" Then strt = "B"
If strt = "c" Then strt = "C"
If strt = "d" Then strt = "D"

If stp = "a" Then stp = "A"
If stp = "b" Then stp = "B"
If stp = "c" Then stp = "C"
If stp = "d" Then stp = "D"

new_mes = ""
flag = 0

'Log(message)
'Log(su.stringLength(message))
'Log(su.Mid(message,0,1))
For i = 0 To su.stringLength(message)-1

    karak = su.Mid(message,i,1)
	If karak <> "0" And karak <> "1" And karak <> "2" And _
	   karak <> "3" And karak <> "4" And karak <> "5" And _
	   karak <> "6" And karak <> "7" And karak <> "8" And _
	   karak <> "9" And karak <> "-" And karak <> "$" And _
	   karak <> ":" And karak <> "." And karak <> "/" And _
	   karak <> "+" Then
	   flag = 1
	   Exit
    End If
	new_mes = new_mes & karak
Next	

message = new_mes

'Log(message)
If flag = 0 Then
  message = build_string(message,strt,stp)
End If

If flag = 1 Then
'  ToastMessageShow ("You are attempting to encode invalid Code11 characters", False)
End If
   
Return message
 
End Sub


Private Sub build_string(message As String, begin As String, einde As String) As String

Dim karak As String
bs = ""
If begin = "A" Then start = "1011001001"
If begin = "B" Then start = "1010010011"
If begin = "C" Then start = "1001001011"
If begin = "D" Then start = "1010011001"

	 
bs = bs & start
bs = bs & "0"

For i = 0 To su.stringLength(message) -1
    karak = su.Mid(message,i,1)
'	Log(karak)
	If karak = "0" Then bs = bs & "101010011"
	If karak = "1" Then bs = bs & "101011001"
	If karak = "2" Then bs = bs & "101001011"
	If karak = "3" Then bs = bs & "110010101"
	If karak = "4" Then bs = bs & "101101001"
	If karak = "5" Then bs = bs & "110101001"
	If karak = "6" Then bs = bs & "100101011"
	If karak = "7" Then bs = bs & "100101101"
	If karak = "8" Then bs = bs & "100110101"
	If karak = "9" Then bs = bs & "110100101"
	If karak = "-" Then bs = bs & "101001101"
	If karak = "$" Then bs = bs & "101100101"
	If karak = ":" Then bs = bs & "1101011011"
	If karak = "/" Then bs = bs & "1101101011"
	If karak = "." Then bs = bs & "1101101101"
	If karak = "+" Then bs = bs & "101100110011"
	bs = bs & "0" 
Next	

If einde = "A" Then fin = "1011001001"
If einde = "B" Then fin = "1010010011"
If einde = "C" Then fin = "1001001011"
If einde = "D" Then fin = "1010011001"	 

bs = bs & fin

Log(bs)
Log(su.stringLength(bs))
Log(message)
Log(begin)
Log(einde)

Return bs

End Sub

